// created with (W)GLextgen by Andreas Kirsch 2003

// once you must #define GL_EXT_INIT_SOURCE/WGL_EXT_INIT_SOURCE
// before including this header.

// To display all supported extensions define WGL_LIST_ALL_EXT
#ifndef __FILE_WGL_EXT_PROC
#define __FILE_WGL_EXT_PROC

// include the default opengl header files
#include <GL\gl.h>
#include <GL\wglext.h>

#ifdef WGL_EXT_INIT_SOURCE
#	include "windows.h"
#	include "string.h"
#endif //WGL_EXT_INIT_SOURCE
#ifdef __cplusplus
extern "C"
{
#endif

GLboolean _wglExtInit(const char *extension);

#ifdef WGL_ARB_buffer_region
#if defined(WGL_LIST_ALL_EXT)
#	pragma message("WGL_ARB_buffer_region supported")
#endif
	PFNWGLCREATEBUFFERREGIONARBPROC wglCreateBufferRegionARB = 0;
	PFNWGLDELETEBUFFERREGIONARBPROC wglDeleteBufferRegionARB = 0;
	PFNWGLSAVEBUFFERREGIONARBPROC wglSaveBufferRegionARB = 0;
	PFNWGLRESTOREBUFFERREGIONARBPROC wglRestoreBufferRegionARB = 0;
#endif //WGL_ARB_buffer_region

#ifdef WGL_ARB_extensions_string
#if defined(WGL_LIST_ALL_EXT)
#	pragma message("WGL_ARB_extensions_string supported")
#endif
	PFNWGLGETEXTENSIONSSTRINGARBPROC wglGetExtensionsStringARB = 0;
#endif //WGL_ARB_extensions_string

#ifdef WGL_ARB_pixel_format
#if defined(WGL_LIST_ALL_EXT)
#	pragma message("WGL_ARB_pixel_format supported")
#endif
	PFNWGLGETPIXELFORMATATTRIBIVARBPROC wglGetPixelFormatAttribivARB = 0;
	PFNWGLGETPIXELFORMATATTRIBFVARBPROC wglGetPixelFormatAttribfvARB = 0;
	PFNWGLCHOOSEPIXELFORMATARBPROC wglChoosePixelFormatARB = 0;
#endif //WGL_ARB_pixel_format

#ifdef WGL_ARB_make_current_read
#if defined(WGL_LIST_ALL_EXT)
#	pragma message("WGL_ARB_make_current_read supported")
#endif
	PFNWGLMAKECONTEXTCURRENTARBPROC wglMakeContextCurrentARB = 0;
	PFNWGLGETCURRENTREADDCARBPROC wglGetCurrentReadDCARB = 0;
#endif //WGL_ARB_make_current_read

#ifdef WGL_ARB_pbuffer
#if defined(WGL_LIST_ALL_EXT)
#	pragma message("WGL_ARB_pbuffer supported")
#endif
	PFNWGLCREATEPBUFFERARBPROC wglCreatePbufferARB = 0;
	PFNWGLGETPBUFFERDCARBPROC wglGetPbufferDCARB = 0;
	PFNWGLRELEASEPBUFFERDCARBPROC wglReleasePbufferDCARB = 0;
	PFNWGLDESTROYPBUFFERARBPROC wglDestroyPbufferARB = 0;
	PFNWGLQUERYPBUFFERARBPROC wglQueryPbufferARB = 0;
#endif //WGL_ARB_pbuffer

#ifdef WGL_ARB_render_texture
#if defined(WGL_LIST_ALL_EXT)
#	pragma message("WGL_ARB_render_texture supported")
#endif
	PFNWGLBINDTEXIMAGEARBPROC wglBindTexImageARB = 0;
	PFNWGLRELEASETEXIMAGEARBPROC wglReleaseTexImageARB = 0;
	PFNWGLSETPBUFFERATTRIBARBPROC wglSetPbufferAttribARB = 0;
#endif //WGL_ARB_render_texture

#ifdef WGL_EXT_display_color_table
#if defined(WGL_LIST_ALL_EXT)
#	pragma message("WGL_EXT_display_color_table supported")
#endif
	PFNWGLCREATEDISPLAYCOLORTABLEEXTPROC wglCreateDisplayColorTableEXT = 0;
	PFNWGLLOADDISPLAYCOLORTABLEEXTPROC wglLoadDisplayColorTableEXT = 0;
	PFNWGLBINDDISPLAYCOLORTABLEEXTPROC wglBindDisplayColorTableEXT = 0;
	PFNWGLDESTROYDISPLAYCOLORTABLEEXTPROC wglDestroyDisplayColorTableEXT = 0;
#endif //WGL_EXT_display_color_table

#ifdef WGL_EXT_extensions_string
#if defined(WGL_LIST_ALL_EXT)
#	pragma message("WGL_EXT_extensions_string supported")
#endif
	PFNWGLGETEXTENSIONSSTRINGEXTPROC wglGetExtensionsStringEXT = 0;
#endif //WGL_EXT_extensions_string

#ifdef WGL_EXT_make_current_read
#if defined(WGL_LIST_ALL_EXT)
#	pragma message("WGL_EXT_make_current_read supported")
#endif
	PFNWGLMAKECONTEXTCURRENTEXTPROC wglMakeContextCurrentEXT = 0;
	PFNWGLGETCURRENTREADDCEXTPROC wglGetCurrentReadDCEXT = 0;
#endif //WGL_EXT_make_current_read

#ifdef WGL_EXT_pbuffer
#if defined(WGL_LIST_ALL_EXT)
#	pragma message("WGL_EXT_pbuffer supported")
#endif
	PFNWGLCREATEPBUFFEREXTPROC wglCreatePbufferEXT = 0;
	PFNWGLGETPBUFFERDCEXTPROC wglGetPbufferDCEXT = 0;
	PFNWGLRELEASEPBUFFERDCEXTPROC wglReleasePbufferDCEXT = 0;
	PFNWGLDESTROYPBUFFEREXTPROC wglDestroyPbufferEXT = 0;
	PFNWGLQUERYPBUFFEREXTPROC wglQueryPbufferEXT = 0;
#endif //WGL_EXT_pbuffer

#ifdef WGL_EXT_pixel_format
#if defined(WGL_LIST_ALL_EXT)
#	pragma message("WGL_EXT_pixel_format supported")
#endif
	PFNWGLGETPIXELFORMATATTRIBIVEXTPROC wglGetPixelFormatAttribivEXT = 0;
	PFNWGLGETPIXELFORMATATTRIBFVEXTPROC wglGetPixelFormatAttribfvEXT = 0;
	PFNWGLCHOOSEPIXELFORMATEXTPROC wglChoosePixelFormatEXT = 0;
#endif //WGL_EXT_pixel_format

#ifdef WGL_EXT_swap_control
#if defined(WGL_LIST_ALL_EXT)
#	pragma message("WGL_EXT_swap_control supported")
#endif
	PFNWGLSWAPINTERVALEXTPROC wglSwapIntervalEXT = 0;
	PFNWGLGETSWAPINTERVALEXTPROC wglGetSwapIntervalEXT = 0;
#endif //WGL_EXT_swap_control

#ifdef WGL_NV_vertex_array_range
#if defined(WGL_LIST_ALL_EXT)
#	pragma message("WGL_NV_vertex_array_range supported")
#endif
	PFNWGLALLOCATEMEMORYNVPROC wglAllocateMemoryNV = 0;
	PFNWGLFREEMEMORYNVPROC wglFreeMemoryNV = 0;
#endif //WGL_NV_vertex_array_range

#ifdef WGL_OML_sync_control
#if defined(WGL_LIST_ALL_EXT)
#	pragma message("WGL_OML_sync_control supported")
#endif
	PFNWGLGETSYNCVALUESOMLPROC wglGetSyncValuesOML = 0;
	PFNWGLGETMSCRATEOMLPROC wglGetMscRateOML = 0;
	PFNWGLSWAPBUFFERSMSCOMLPROC wglSwapBuffersMscOML = 0;
	PFNWGLSWAPLAYERBUFFERSMSCOMLPROC wglSwapLayerBuffersMscOML = 0;
	PFNWGLWAITFORMSCOMLPROC wglWaitForMscOML = 0;
	PFNWGLWAITFORSBCOMLPROC wglWaitForSbcOML = 0;
#endif //WGL_OML_sync_control

#ifdef WGL_I3D_digital_video_control
#if defined(WGL_LIST_ALL_EXT)
#	pragma message("WGL_I3D_digital_video_control supported")
#endif
	PFNWGLGETDIGITALVIDEOPARAMETERSI3DPROC wglGetDigitalVideoParametersI3D = 0;
	PFNWGLSETDIGITALVIDEOPARAMETERSI3DPROC wglSetDigitalVideoParametersI3D = 0;
#endif //WGL_I3D_digital_video_control

#ifdef WGL_I3D_gamma
#if defined(WGL_LIST_ALL_EXT)
#	pragma message("WGL_I3D_gamma supported")
#endif
	PFNWGLGETGAMMATABLEPARAMETERSI3DPROC wglGetGammaTableParametersI3D = 0;
	PFNWGLSETGAMMATABLEPARAMETERSI3DPROC wglSetGammaTableParametersI3D = 0;
	PFNWGLGETGAMMATABLEI3DPROC wglGetGammaTableI3D = 0;
	PFNWGLSETGAMMATABLEI3DPROC wglSetGammaTableI3D = 0;
#endif //WGL_I3D_gamma

#ifdef WGL_I3D_genlock
#if defined(WGL_LIST_ALL_EXT)
#	pragma message("WGL_I3D_genlock supported")
#endif
	PFNWGLENABLEGENLOCKI3DPROC wglEnableGenlockI3D = 0;
	PFNWGLDISABLEGENLOCKI3DPROC wglDisableGenlockI3D = 0;
	PFNWGLISENABLEDGENLOCKI3DPROC wglIsEnabledGenlockI3D = 0;
	PFNWGLGENLOCKSOURCEI3DPROC wglGenlockSourceI3D = 0;
	PFNWGLGETGENLOCKSOURCEI3DPROC wglGetGenlockSourceI3D = 0;
	PFNWGLGENLOCKSOURCEEDGEI3DPROC wglGenlockSourceEdgeI3D = 0;
	PFNWGLGETGENLOCKSOURCEEDGEI3DPROC wglGetGenlockSourceEdgeI3D = 0;
	PFNWGLGENLOCKSAMPLERATEI3DPROC wglGenlockSampleRateI3D = 0;
	PFNWGLGETGENLOCKSAMPLERATEI3DPROC wglGetGenlockSampleRateI3D = 0;
	PFNWGLGENLOCKSOURCEDELAYI3DPROC wglGenlockSourceDelayI3D = 0;
	PFNWGLGETGENLOCKSOURCEDELAYI3DPROC wglGetGenlockSourceDelayI3D = 0;
	PFNWGLQUERYGENLOCKMAXSOURCEDELAYI3DPROC wglQueryGenlockMaxSourceDelayI3D = 0;
#endif //WGL_I3D_genlock

#ifdef WGL_I3D_image_buffer
#if defined(WGL_LIST_ALL_EXT)
#	pragma message("WGL_I3D_image_buffer supported")
#endif
	PFNWGLCREATEIMAGEBUFFERI3DPROC wglCreateImageBufferI3D = 0;
	PFNWGLDESTROYIMAGEBUFFERI3DPROC wglDestroyImageBufferI3D = 0;
	PFNWGLASSOCIATEIMAGEBUFFEREVENTSI3DPROC wglAssociateImageBufferEventsI3D = 0;
	PFNWGLRELEASEIMAGEBUFFEREVENTSI3DPROC wglReleaseImageBufferEventsI3D = 0;
#endif //WGL_I3D_image_buffer

#ifdef WGL_I3D_swap_frame_lock
#if defined(WGL_LIST_ALL_EXT)
#	pragma message("WGL_I3D_swap_frame_lock supported")
#endif
	PFNWGLENABLEFRAMELOCKI3DPROC wglEnableFrameLockI3D = 0;
	PFNWGLDISABLEFRAMELOCKI3DPROC wglDisableFrameLockI3D = 0;
	PFNWGLISENABLEDFRAMELOCKI3DPROC wglIsEnabledFrameLockI3D = 0;
	PFNWGLQUERYFRAMELOCKMASTERI3DPROC wglQueryFrameLockMasterI3D = 0;
#endif //WGL_I3D_swap_frame_lock

#ifdef WGL_I3D_swap_frame_usage
#if defined(WGL_LIST_ALL_EXT)
#	pragma message("WGL_I3D_swap_frame_usage supported")
#endif
	PFNWGLGETFRAMEUSAGEI3DPROC wglGetFrameUsageI3D = 0;
	PFNWGLBEGINFRAMETRACKINGI3DPROC wglBeginFrameTrackingI3D = 0;
	PFNWGLENDFRAMETRACKINGI3DPROC wglEndFrameTrackingI3D = 0;
	PFNWGLQUERYFRAMETRACKINGI3DPROC wglQueryFrameTrackingI3D = 0;
#endif //WGL_I3D_swap_frame_usage

#ifdef WGL_EXT_INIT_SOURCE

GLboolean _wglExtInit(const char *extension)
{
	if(extension == 0)
		return GL_FALSE;
#ifdef WGL_ARB_buffer_region
	else if(0 == strcmp("WGL_ARB_buffer_region",extension))
	{
		wglCreateBufferRegionARB = (PFNWGLCREATEBUFFERREGIONARBPROC)wglGetProcAddress("wglCreateBufferRegionARB");
		if(wglCreateBufferRegionARB == 0)
			return GL_FALSE;
		wglDeleteBufferRegionARB = (PFNWGLDELETEBUFFERREGIONARBPROC)wglGetProcAddress("wglDeleteBufferRegionARB");
		if(wglDeleteBufferRegionARB == 0)
			return GL_FALSE;
		wglSaveBufferRegionARB = (PFNWGLSAVEBUFFERREGIONARBPROC)wglGetProcAddress("wglSaveBufferRegionARB");
		if(wglSaveBufferRegionARB == 0)
			return GL_FALSE;
		wglRestoreBufferRegionARB = (PFNWGLRESTOREBUFFERREGIONARBPROC)wglGetProcAddress("wglRestoreBufferRegionARB");
		if(wglRestoreBufferRegionARB == 0)
			return GL_FALSE;
	}
#endif //WGL_ARB_buffer_region
#ifdef WGL_ARB_extensions_string
	else if(0 == strcmp("WGL_ARB_extensions_string",extension))
	{
		wglGetExtensionsStringARB = (PFNWGLGETEXTENSIONSSTRINGARBPROC)wglGetProcAddress("wglGetExtensionsStringARB");
		if(wglGetExtensionsStringARB == 0)
			return GL_FALSE;
	}
#endif //WGL_ARB_extensions_string
#ifdef WGL_ARB_pixel_format
	else if(0 == strcmp("WGL_ARB_pixel_format",extension))
	{
		wglGetPixelFormatAttribivARB = (PFNWGLGETPIXELFORMATATTRIBIVARBPROC)wglGetProcAddress("wglGetPixelFormatAttribivARB");
		if(wglGetPixelFormatAttribivARB == 0)
			return GL_FALSE;
		wglGetPixelFormatAttribfvARB = (PFNWGLGETPIXELFORMATATTRIBFVARBPROC)wglGetProcAddress("wglGetPixelFormatAttribfvARB");
		if(wglGetPixelFormatAttribfvARB == 0)
			return GL_FALSE;
		wglChoosePixelFormatARB = (PFNWGLCHOOSEPIXELFORMATARBPROC)wglGetProcAddress("wglChoosePixelFormatARB");
		if(wglChoosePixelFormatARB == 0)
			return GL_FALSE;
	}
#endif //WGL_ARB_pixel_format
#ifdef WGL_ARB_make_current_read
	else if(0 == strcmp("WGL_ARB_make_current_read",extension))
	{
		wglMakeContextCurrentARB = (PFNWGLMAKECONTEXTCURRENTARBPROC)wglGetProcAddress("wglMakeContextCurrentARB");
		if(wglMakeContextCurrentARB == 0)
			return GL_FALSE;
		wglGetCurrentReadDCARB = (PFNWGLGETCURRENTREADDCARBPROC)wglGetProcAddress("wglGetCurrentReadDCARB");
		if(wglGetCurrentReadDCARB == 0)
			return GL_FALSE;
	}
#endif //WGL_ARB_make_current_read
#ifdef WGL_ARB_pbuffer
	else if(0 == strcmp("WGL_ARB_pbuffer",extension))
	{
		wglCreatePbufferARB = (PFNWGLCREATEPBUFFERARBPROC)wglGetProcAddress("wglCreatePbufferARB");
		if(wglCreatePbufferARB == 0)
			return GL_FALSE;
		wglGetPbufferDCARB = (PFNWGLGETPBUFFERDCARBPROC)wglGetProcAddress("wglGetPbufferDCARB");
		if(wglGetPbufferDCARB == 0)
			return GL_FALSE;
		wglReleasePbufferDCARB = (PFNWGLRELEASEPBUFFERDCARBPROC)wglGetProcAddress("wglReleasePbufferDCARB");
		if(wglReleasePbufferDCARB == 0)
			return GL_FALSE;
		wglDestroyPbufferARB = (PFNWGLDESTROYPBUFFERARBPROC)wglGetProcAddress("wglDestroyPbufferARB");
		if(wglDestroyPbufferARB == 0)
			return GL_FALSE;
		wglQueryPbufferARB = (PFNWGLQUERYPBUFFERARBPROC)wglGetProcAddress("wglQueryPbufferARB");
		if(wglQueryPbufferARB == 0)
			return GL_FALSE;
	}
#endif //WGL_ARB_pbuffer
#ifdef WGL_ARB_render_texture
	else if(0 == strcmp("WGL_ARB_render_texture",extension))
	{
		wglBindTexImageARB = (PFNWGLBINDTEXIMAGEARBPROC)wglGetProcAddress("wglBindTexImageARB");
		if(wglBindTexImageARB == 0)
			return GL_FALSE;
		wglReleaseTexImageARB = (PFNWGLRELEASETEXIMAGEARBPROC)wglGetProcAddress("wglReleaseTexImageARB");
		if(wglReleaseTexImageARB == 0)
			return GL_FALSE;
		wglSetPbufferAttribARB = (PFNWGLSETPBUFFERATTRIBARBPROC)wglGetProcAddress("wglSetPbufferAttribARB");
		if(wglSetPbufferAttribARB == 0)
			return GL_FALSE;
	}
#endif //WGL_ARB_render_texture
#ifdef WGL_EXT_display_color_table
	else if(0 == strcmp("WGL_EXT_display_color_table",extension))
	{
		wglCreateDisplayColorTableEXT = (PFNWGLCREATEDISPLAYCOLORTABLEEXTPROC)wglGetProcAddress("wglCreateDisplayColorTableEXT");
		if(wglCreateDisplayColorTableEXT == 0)
			return GL_FALSE;
		wglLoadDisplayColorTableEXT = (PFNWGLLOADDISPLAYCOLORTABLEEXTPROC)wglGetProcAddress("wglLoadDisplayColorTableEXT");
		if(wglLoadDisplayColorTableEXT == 0)
			return GL_FALSE;
		wglBindDisplayColorTableEXT = (PFNWGLBINDDISPLAYCOLORTABLEEXTPROC)wglGetProcAddress("wglBindDisplayColorTableEXT");
		if(wglBindDisplayColorTableEXT == 0)
			return GL_FALSE;
		wglDestroyDisplayColorTableEXT = (PFNWGLDESTROYDISPLAYCOLORTABLEEXTPROC)wglGetProcAddress("wglDestroyDisplayColorTableEXT");
		if(wglDestroyDisplayColorTableEXT == 0)
			return GL_FALSE;
	}
#endif //WGL_EXT_display_color_table
#ifdef WGL_EXT_extensions_string
	else if(0 == strcmp("WGL_EXT_extensions_string",extension))
	{
		wglGetExtensionsStringEXT = (PFNWGLGETEXTENSIONSSTRINGEXTPROC)wglGetProcAddress("wglGetExtensionsStringEXT");
		if(wglGetExtensionsStringEXT == 0)
			return GL_FALSE;
	}
#endif //WGL_EXT_extensions_string
#ifdef WGL_EXT_make_current_read
	else if(0 == strcmp("WGL_EXT_make_current_read",extension))
	{
		wglMakeContextCurrentEXT = (PFNWGLMAKECONTEXTCURRENTEXTPROC)wglGetProcAddress("wglMakeContextCurrentEXT");
		if(wglMakeContextCurrentEXT == 0)
			return GL_FALSE;
		wglGetCurrentReadDCEXT = (PFNWGLGETCURRENTREADDCEXTPROC)wglGetProcAddress("wglGetCurrentReadDCEXT");
		if(wglGetCurrentReadDCEXT == 0)
			return GL_FALSE;
	}
#endif //WGL_EXT_make_current_read
#ifdef WGL_EXT_pbuffer
	else if(0 == strcmp("WGL_EXT_pbuffer",extension))
	{
		wglCreatePbufferEXT = (PFNWGLCREATEPBUFFEREXTPROC)wglGetProcAddress("wglCreatePbufferEXT");
		if(wglCreatePbufferEXT == 0)
			return GL_FALSE;
		wglGetPbufferDCEXT = (PFNWGLGETPBUFFERDCEXTPROC)wglGetProcAddress("wglGetPbufferDCEXT");
		if(wglGetPbufferDCEXT == 0)
			return GL_FALSE;
		wglReleasePbufferDCEXT = (PFNWGLRELEASEPBUFFERDCEXTPROC)wglGetProcAddress("wglReleasePbufferDCEXT");
		if(wglReleasePbufferDCEXT == 0)
			return GL_FALSE;
		wglDestroyPbufferEXT = (PFNWGLDESTROYPBUFFEREXTPROC)wglGetProcAddress("wglDestroyPbufferEXT");
		if(wglDestroyPbufferEXT == 0)
			return GL_FALSE;
		wglQueryPbufferEXT = (PFNWGLQUERYPBUFFEREXTPROC)wglGetProcAddress("wglQueryPbufferEXT");
		if(wglQueryPbufferEXT == 0)
			return GL_FALSE;
	}
#endif //WGL_EXT_pbuffer
#ifdef WGL_EXT_pixel_format
	else if(0 == strcmp("WGL_EXT_pixel_format",extension))
	{
		wglGetPixelFormatAttribivEXT = (PFNWGLGETPIXELFORMATATTRIBIVEXTPROC)wglGetProcAddress("wglGetPixelFormatAttribivEXT");
		if(wglGetPixelFormatAttribivEXT == 0)
			return GL_FALSE;
		wglGetPixelFormatAttribfvEXT = (PFNWGLGETPIXELFORMATATTRIBFVEXTPROC)wglGetProcAddress("wglGetPixelFormatAttribfvEXT");
		if(wglGetPixelFormatAttribfvEXT == 0)
			return GL_FALSE;
		wglChoosePixelFormatEXT = (PFNWGLCHOOSEPIXELFORMATEXTPROC)wglGetProcAddress("wglChoosePixelFormatEXT");
		if(wglChoosePixelFormatEXT == 0)
			return GL_FALSE;
	}
#endif //WGL_EXT_pixel_format
#ifdef WGL_EXT_swap_control
	else if(0 == strcmp("WGL_EXT_swap_control",extension))
	{
		wglSwapIntervalEXT = (PFNWGLSWAPINTERVALEXTPROC)wglGetProcAddress("wglSwapIntervalEXT");
		if(wglSwapIntervalEXT == 0)
			return GL_FALSE;
		wglGetSwapIntervalEXT = (PFNWGLGETSWAPINTERVALEXTPROC)wglGetProcAddress("wglGetSwapIntervalEXT");
		if(wglGetSwapIntervalEXT == 0)
			return GL_FALSE;
	}
#endif //WGL_EXT_swap_control
#ifdef WGL_NV_vertex_array_range
	else if(0 == strcmp("WGL_NV_vertex_array_range",extension))
	{
		wglAllocateMemoryNV = (PFNWGLALLOCATEMEMORYNVPROC)wglGetProcAddress("wglAllocateMemoryNV");
		if(wglAllocateMemoryNV == 0)
			return GL_FALSE;
		wglFreeMemoryNV = (PFNWGLFREEMEMORYNVPROC)wglGetProcAddress("wglFreeMemoryNV");
		if(wglFreeMemoryNV == 0)
			return GL_FALSE;
	}
#endif //WGL_NV_vertex_array_range
#ifdef WGL_OML_sync_control
	else if(0 == strcmp("WGL_OML_sync_control",extension))
	{
		wglGetSyncValuesOML = (PFNWGLGETSYNCVALUESOMLPROC)wglGetProcAddress("wglGetSyncValuesOML");
		if(wglGetSyncValuesOML == 0)
			return GL_FALSE;
		wglGetMscRateOML = (PFNWGLGETMSCRATEOMLPROC)wglGetProcAddress("wglGetMscRateOML");
		if(wglGetMscRateOML == 0)
			return GL_FALSE;
		wglSwapBuffersMscOML = (PFNWGLSWAPBUFFERSMSCOMLPROC)wglGetProcAddress("wglSwapBuffersMscOML");
		if(wglSwapBuffersMscOML == 0)
			return GL_FALSE;
		wglSwapLayerBuffersMscOML = (PFNWGLSWAPLAYERBUFFERSMSCOMLPROC)wglGetProcAddress("wglSwapLayerBuffersMscOML");
		if(wglSwapLayerBuffersMscOML == 0)
			return GL_FALSE;
		wglWaitForMscOML = (PFNWGLWAITFORMSCOMLPROC)wglGetProcAddress("wglWaitForMscOML");
		if(wglWaitForMscOML == 0)
			return GL_FALSE;
		wglWaitForSbcOML = (PFNWGLWAITFORSBCOMLPROC)wglGetProcAddress("wglWaitForSbcOML");
		if(wglWaitForSbcOML == 0)
			return GL_FALSE;
	}
#endif //WGL_OML_sync_control
#ifdef WGL_I3D_digital_video_control
	else if(0 == strcmp("WGL_I3D_digital_video_control",extension))
	{
		wglGetDigitalVideoParametersI3D = (PFNWGLGETDIGITALVIDEOPARAMETERSI3DPROC)wglGetProcAddress("wglGetDigitalVideoParametersI3D");
		if(wglGetDigitalVideoParametersI3D == 0)
			return GL_FALSE;
		wglSetDigitalVideoParametersI3D = (PFNWGLSETDIGITALVIDEOPARAMETERSI3DPROC)wglGetProcAddress("wglSetDigitalVideoParametersI3D");
		if(wglSetDigitalVideoParametersI3D == 0)
			return GL_FALSE;
	}
#endif //WGL_I3D_digital_video_control
#ifdef WGL_I3D_gamma
	else if(0 == strcmp("WGL_I3D_gamma",extension))
	{
		wglGetGammaTableParametersI3D = (PFNWGLGETGAMMATABLEPARAMETERSI3DPROC)wglGetProcAddress("wglGetGammaTableParametersI3D");
		if(wglGetGammaTableParametersI3D == 0)
			return GL_FALSE;
		wglSetGammaTableParametersI3D = (PFNWGLSETGAMMATABLEPARAMETERSI3DPROC)wglGetProcAddress("wglSetGammaTableParametersI3D");
		if(wglSetGammaTableParametersI3D == 0)
			return GL_FALSE;
		wglGetGammaTableI3D = (PFNWGLGETGAMMATABLEI3DPROC)wglGetProcAddress("wglGetGammaTableI3D");
		if(wglGetGammaTableI3D == 0)
			return GL_FALSE;
		wglSetGammaTableI3D = (PFNWGLSETGAMMATABLEI3DPROC)wglGetProcAddress("wglSetGammaTableI3D");
		if(wglSetGammaTableI3D == 0)
			return GL_FALSE;
	}
#endif //WGL_I3D_gamma
#ifdef WGL_I3D_genlock
	else if(0 == strcmp("WGL_I3D_genlock",extension))
	{
		wglEnableGenlockI3D = (PFNWGLENABLEGENLOCKI3DPROC)wglGetProcAddress("wglEnableGenlockI3D");
		if(wglEnableGenlockI3D == 0)
			return GL_FALSE;
		wglDisableGenlockI3D = (PFNWGLDISABLEGENLOCKI3DPROC)wglGetProcAddress("wglDisableGenlockI3D");
		if(wglDisableGenlockI3D == 0)
			return GL_FALSE;
		wglIsEnabledGenlockI3D = (PFNWGLISENABLEDGENLOCKI3DPROC)wglGetProcAddress("wglIsEnabledGenlockI3D");
		if(wglIsEnabledGenlockI3D == 0)
			return GL_FALSE;
		wglGenlockSourceI3D = (PFNWGLGENLOCKSOURCEI3DPROC)wglGetProcAddress("wglGenlockSourceI3D");
		if(wglGenlockSourceI3D == 0)
			return GL_FALSE;
		wglGetGenlockSourceI3D = (PFNWGLGETGENLOCKSOURCEI3DPROC)wglGetProcAddress("wglGetGenlockSourceI3D");
		if(wglGetGenlockSourceI3D == 0)
			return GL_FALSE;
		wglGenlockSourceEdgeI3D = (PFNWGLGENLOCKSOURCEEDGEI3DPROC)wglGetProcAddress("wglGenlockSourceEdgeI3D");
		if(wglGenlockSourceEdgeI3D == 0)
			return GL_FALSE;
		wglGetGenlockSourceEdgeI3D = (PFNWGLGETGENLOCKSOURCEEDGEI3DPROC)wglGetProcAddress("wglGetGenlockSourceEdgeI3D");
		if(wglGetGenlockSourceEdgeI3D == 0)
			return GL_FALSE;
		wglGenlockSampleRateI3D = (PFNWGLGENLOCKSAMPLERATEI3DPROC)wglGetProcAddress("wglGenlockSampleRateI3D");
		if(wglGenlockSampleRateI3D == 0)
			return GL_FALSE;
		wglGetGenlockSampleRateI3D = (PFNWGLGETGENLOCKSAMPLERATEI3DPROC)wglGetProcAddress("wglGetGenlockSampleRateI3D");
		if(wglGetGenlockSampleRateI3D == 0)
			return GL_FALSE;
		wglGenlockSourceDelayI3D = (PFNWGLGENLOCKSOURCEDELAYI3DPROC)wglGetProcAddress("wglGenlockSourceDelayI3D");
		if(wglGenlockSourceDelayI3D == 0)
			return GL_FALSE;
		wglGetGenlockSourceDelayI3D = (PFNWGLGETGENLOCKSOURCEDELAYI3DPROC)wglGetProcAddress("wglGetGenlockSourceDelayI3D");
		if(wglGetGenlockSourceDelayI3D == 0)
			return GL_FALSE;
		wglQueryGenlockMaxSourceDelayI3D = (PFNWGLQUERYGENLOCKMAXSOURCEDELAYI3DPROC)wglGetProcAddress("wglQueryGenlockMaxSourceDelayI3D");
		if(wglQueryGenlockMaxSourceDelayI3D == 0)
			return GL_FALSE;
	}
#endif //WGL_I3D_genlock
#ifdef WGL_I3D_image_buffer
	else if(0 == strcmp("WGL_I3D_image_buffer",extension))
	{
		wglCreateImageBufferI3D = (PFNWGLCREATEIMAGEBUFFERI3DPROC)wglGetProcAddress("wglCreateImageBufferI3D");
		if(wglCreateImageBufferI3D == 0)
			return GL_FALSE;
		wglDestroyImageBufferI3D = (PFNWGLDESTROYIMAGEBUFFERI3DPROC)wglGetProcAddress("wglDestroyImageBufferI3D");
		if(wglDestroyImageBufferI3D == 0)
			return GL_FALSE;
		wglAssociateImageBufferEventsI3D = (PFNWGLASSOCIATEIMAGEBUFFEREVENTSI3DPROC)wglGetProcAddress("wglAssociateImageBufferEventsI3D");
		if(wglAssociateImageBufferEventsI3D == 0)
			return GL_FALSE;
		wglReleaseImageBufferEventsI3D = (PFNWGLRELEASEIMAGEBUFFEREVENTSI3DPROC)wglGetProcAddress("wglReleaseImageBufferEventsI3D");
		if(wglReleaseImageBufferEventsI3D == 0)
			return GL_FALSE;
	}
#endif //WGL_I3D_image_buffer
#ifdef WGL_I3D_swap_frame_lock
	else if(0 == strcmp("WGL_I3D_swap_frame_lock",extension))
	{
		wglEnableFrameLockI3D = (PFNWGLENABLEFRAMELOCKI3DPROC)wglGetProcAddress("wglEnableFrameLockI3D");
		if(wglEnableFrameLockI3D == 0)
			return GL_FALSE;
		wglDisableFrameLockI3D = (PFNWGLDISABLEFRAMELOCKI3DPROC)wglGetProcAddress("wglDisableFrameLockI3D");
		if(wglDisableFrameLockI3D == 0)
			return GL_FALSE;
		wglIsEnabledFrameLockI3D = (PFNWGLISENABLEDFRAMELOCKI3DPROC)wglGetProcAddress("wglIsEnabledFrameLockI3D");
		if(wglIsEnabledFrameLockI3D == 0)
			return GL_FALSE;
		wglQueryFrameLockMasterI3D = (PFNWGLQUERYFRAMELOCKMASTERI3DPROC)wglGetProcAddress("wglQueryFrameLockMasterI3D");
		if(wglQueryFrameLockMasterI3D == 0)
			return GL_FALSE;
	}
#endif //WGL_I3D_swap_frame_lock
#ifdef WGL_I3D_swap_frame_usage
	else if(0 == strcmp("WGL_I3D_swap_frame_usage",extension))
	{
		wglGetFrameUsageI3D = (PFNWGLGETFRAMEUSAGEI3DPROC)wglGetProcAddress("wglGetFrameUsageI3D");
		if(wglGetFrameUsageI3D == 0)
			return GL_FALSE;
		wglBeginFrameTrackingI3D = (PFNWGLBEGINFRAMETRACKINGI3DPROC)wglGetProcAddress("wglBeginFrameTrackingI3D");
		if(wglBeginFrameTrackingI3D == 0)
			return GL_FALSE;
		wglEndFrameTrackingI3D = (PFNWGLENDFRAMETRACKINGI3DPROC)wglGetProcAddress("wglEndFrameTrackingI3D");
		if(wglEndFrameTrackingI3D == 0)
			return GL_FALSE;
		wglQueryFrameTrackingI3D = (PFNWGLQUERYFRAMETRACKINGI3DPROC)wglGetProcAddress("wglQueryFrameTrackingI3D");
		if(wglQueryFrameTrackingI3D == 0)
			return GL_FALSE;
	}
#endif //WGL_I3D_swap_frame_usage
	else
		return GL_FALSE;

	return GL_TRUE;
}

#endif WGL_EXT_INIT_SOURCE

#ifdef __cplusplus
}
#endif

#undef EXTDECL
#endif //__FILE_WGL_EXT_PROC

